<div class="modal-overall-wrapper" *ngIf="visible">
    <div class="modal-container" [@flyInOut]>
        <div class="modal">
            <div class="content">
                <div class="header">
                    <a href="#" class="close" (click)="onCloseModalLinkClicked()">
                        <i class="fa fa-close"></i>
                        <span>Close</span>
                    </a>
                </div>

                <div class="body">
                    <h1 class="registration-header">Registration</h1>

                    <div class="form">
                        <div class="required-fields-tip">
                            <span class="asterisk">*</span> Indicates required fields
                        </div>

                        <form (submit)="onRegistrationFormSubmit()" role="form" class="registration-form"
                              [formGroup]="registrationForm" novalidate>
                            <div class="form-block">
                                <div class="form-block-content">
                                    <div class="label">
                                        Name <span class="asterisk">*</span>
                                    </div>

                                    <div class="input">
                                        <input type="text"
                                               [class.bad]="!registrationForm.get('name').valid && registrationForm.get('name').dirty"
                                               formControlName="name"/>
                                    </div>
                                </div>

                                <div class="field-validation-error"
                                     *ngIf="!registrationForm.get('name').valid && registrationForm.get('name').dirty">
                                    <div class="error-icon">
                                        <span class="exclamation">!</span>
                                        <span *ngIf="registrationForm.get('name').errors?.required">
                                        This field can't be blank
                                    </span>
                                        <span *ngIf="registrationForm.get('name').errors?.pattern">
                                        Name can contain only letters
                                    </span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-block">
                                <div class="form-block-content">
                                    <div class="label">
                                        E-mail <span class="asterisk">*</span>
                                    </div>

                                    <div class="input">
                                        <input type="text" formControlName="email"
                                               [class.bad]="registrationForm.get('email').dirty && !registrationForm.get('email').valid"/>
                                    </div>
                                </div>

                                <div class="field-validation-error"
                                     *ngIf="registrationForm.get('email').dirty && !registrationForm.get('email').valid">
                                    <div class="error-icon">
                                        <span class="exclamation">!</span>
                                        <span *ngIf="registrationForm.get('email').errors?.required">This field can't be blank</span>
                                        <span *ngIf="registrationForm.get('email').errors?.pattern">Invalid email</span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-block">
                                <div class="form-block-content">
                                    <div class="label">
                                        IP addresses <span class="asterisk">*</span>
                                    </div>

                                    <div class="input">
                                        <div class="ip-input-wrapper">
                                            <div class="ip-input">
                                                <input type="text" formControlName="ip" maxlength="15"
                                                       [class.bad]="registrationForm.get('ip').dirty
                                                   && !registrationForm.get('ip').valid
                                                   && registrationForm.get('ip').value.split('.').length >= 4
                                                   && registrationForm.get('ip').value.split('.')[3]?.length >= 1"
                                                       (keyup)="onIpInputKeyUp($event)"
                                                       (focus)="isIpAddressInputFocused = true"
                                                       (blur)="isIpAddressInputFocused = false"/>
                                            </div>

                                            <div class="add-ip-wrapper">
                                                <a href="#" class="add-ip-link"
                                                   [class.disabled]="!registrationForm.get('ip').valid || !registrationForm.get('ip').value?.length"
                                                   (click)="onAddIpButtonClicked()">
                                                    <span class="plus">+</span> add IP
                                                </a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="field-validation-error"
                                     *ngIf="!registrationForm.get('ip').valid
                                        && registrationForm.get('ip').dirty
                                        && registrationForm.get('ip').value.split('.').length >= 4
                                        && registrationForm.get('ip').value.split('.')[3]?.length >= 1"
                                >
                                    <div class="error-icon">
                                        <span class="exclamation">!</span>
                                        <span *ngIf="registrationForm.get('ip').errors?.pattern">Invalid IP address</span>
                                        <span *ngIf="registrationForm.get('ip').errors?.limitReached">Reached limit of {{ipAddressesLimit}} addresses</span>
                                        <span *ngIf="registrationForm.get('ip').errors?.alreadyInList">You have already entered this IP address</span>
                                    </div>
                                </div>

                                <div class="ip-list-wrapper">
                                    <div class="item" *ngFor="let ip of ipAddressesList">
                                        <span class="ip">{{ip}}</span>
                                        <a href="#" class="remove" (click)="onRemoveIpButtonClicked(ip)">
                                            <i class="fa fa-remove"></i> remove
                                        </a>

                                    </div>
                                </div>
                            </div>

                            <div class="form-block">
                                <div class="form-block-content">
                                    <div class="label">
                                        Password <span class="asterisk">*</span>
                                    </div>

                                    <div class="input">
                                        <input type="password" formControlName="password"
                                               [class.bad]="registrationForm.get('password').dirty && !registrationForm.get('password').valid"/>
                                    </div>
                                </div>

                                <div class="field-validation-error"
                                     *ngIf="registrationForm.get('password').dirty && !registrationForm.get('password').valid">
                                    <div class="error-icon">
                                        <span class="exclamation">!</span>
                                        <span *ngIf="registrationForm.get('password').errors?.required">This field can't be blank</span>
                                        <span *ngIf="registrationForm.get('password').errors?.minlength">Minimum length is 6 symbols</span>
                                        <span *ngIf="registrationForm.get('password').errors?.maxlength">Maximum length is 16 symbols</span>
                                    </div>
                                </div>
                            </div>

                            <div class="form-block">
                                <div class="form-block-content">
                                    <div class="label">
                                        Confirm password <span class="asterisk">*</span>
                                    </div>

                                    <div class="input">
                                        <input type="password" formControlName="confirmPassword"/>
                                    </div>
                                </div>

                                <div class="field-validation-error"
                                     *ngIf="registrationForm.get('confirmPassword').dirty && (!registrationForm.get('confirmPassword').valid || !passwordsAreMatches())">
                                    <div class="error-icon">
                                        <span class="exclamation">!</span>
                                        <span *ngIf="registrationForm.get('confirmPassword').errors?.required && registrationForm.get('confirmPassword').dirty">This field can't be blank</span>
                                        <span *ngIf="!passwordsAreMatches() && !registrationForm.get('confirmPassword').errors?.required">Passwords must be match</span>
                                    </div>
                                </div>
                            </div>

                            <div class="footer">
                                <app-button [color]="'blue'" [big]="true" [label]="'Submit'"
                                            [disabled]="!registrationForm.valid || !passwordsAreMatches() || !ipAddressesList.length"></app-button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="backdrop"></div>
</div>
